Attribute VB_Name = "mdlExt"
Option Explicit
'-------------------------------------------------------------------------------------------
'Author           : Paul Dahuach
'Year             : 2008
'Legal            : Do whatever you want with it, send me some feedback if you want.
'More Examples    : http://www.pauldahuach.com.ar/program_en.htm
'-------------------------------------------------------------------------------------------
Public Const WIN32_LEAN_AND_MEAN            As Long = 1

Public Const GL_ARB_multitexture            As Long = 1
Public Const GL_EXT_abgr                    As Long = 1
Public Const GL_EXT_bgra                    As Long = 1
Public Const GL_EXT_clip_volume_hint        As Long = 1
Public Const GL_EXT_compiled_vertex_array   As Long = 1
Public Const GL_EXT_cull_vertex             As Long = 1
Public Const GL_EXT_packed_pixels           As Long = 1
Public Const GL_EXT_point_parameters        As Long = 1
Public Const GL_EXT_stencil_wrap            As Long = 1
Public Const GL_EXT_texture_env_add         As Long = 1
Public Const GL_EXT_texture_env_combine     As Long = 1
Public Const GL_EXT_vertex_array            As Long = 1
Public Const GL_NV_texgen_reflection        As Long = 1
Public Const GL_NV_texture_env_combine4     As Long = 1
Public Const GL_WIN_swap_hint               As Long = 1

' EXT_abgr '
Public Const GL_ABGR_EXT                    As Long = &H8000

' EXT_packed_pixels '
Public Const GL_UNSIGNED_BYTE_3_3_2_EXT     As Long = &H8032
Public Const GL_UNSIGNED_SHORT_4_4_4_4_EXT  As Long = &H8033
Public Const GL_UNSIGNED_SHORT_5_5_5_1_EXT  As Long = &H8034
Public Const GL_UNSIGNED_INT_8_8_8_8_EXT    As Long = &H8035
Public Const GL_UNSIGNED_INT_10_10_10_2_EXT As Long = &H8036

' EXT_vertex_array '
Public Const GL_VERTEX_ARRAY_EXT            As Long = &H8074
Public Const GL_NORMAL_ARRAY_EXT            As Long = &H8075
Public Const GL_COLOR_ARRAY_EXT             As Long = &H8076
Public Const GL_INDEX_ARRAY_EXT             As Long = &H8077
Public Const GL_TEXTURE_COORD_ARRAY_EXT     As Long = &H8078
Public Const GL_EDGE_FLAG_ARRAY_EXT         As Long = &H8079
Public Const GL_VERTEX_ARRAY_SIZE_EXT       As Long = &H807A
Public Const GL_VERTEX_ARRAY_TYPE_EXT       As Long = &H807B
Public Const GL_VERTEX_ARRAY_STRIDE_EXT     As Long = &H807C
Public Const GL_VERTEX_ARRAY_COUNT_EXT      As Long = &H807D
Public Const GL_NORMAL_ARRAY_TYPE_EXT       As Long = &H807E
Public Const GL_NORMAL_ARRAY_STRIDE_EXT     As Long = &H807F
Public Const GL_NORMAL_ARRAY_COUNT_EXT      As Long = &H8080
Public Const GL_COLOR_ARRAY_SIZE_EXT        As Long = &H8081
Public Const GL_COLOR_ARRAY_TYPE_EXT        As Long = &H8082
Public Const GL_COLOR_ARRAY_STRIDE_EXT      As Long = &H8083
Public Const GL_COLOR_ARRAY_COUNT_EXT       As Long = &H8084
Public Const GL_INDEX_ARRAY_TYPE_EXT        As Long = &H8085
Public Const GL_INDEX_ARRAY_STRIDE_EXT      As Long = &H8086
Public Const GL_INDEX_ARRAY_COUNT_EXT       As Long = &H8087
Public Const GL_TEXTURE_COORD_ARRAY_SIZE_EXT    As Long = &H8088
Public Const GL_TEXTURE_COORD_ARRAY_TYPE_EXT    As Long = &H8089
Public Const GL_TEXTURE_COORD_ARRAY_STRIDE_EXT  As Long = &H808A
Public Const GL_TEXTURE_COORD_ARRAY_COUNT_EXT   As Long = &H808B
Public Const GL_EDGE_FLAG_ARRAY_STRIDE_EXT      As Long = &H808C
Public Const GL_EDGE_FLAG_ARRAY_COUNT_EXT       As Long = &H808D
Public Const GL_VERTEX_ARRAY_POINTER_EXT        As Long = &H808E
Public Const GL_NORMAL_ARRAY_POINTER_EXT        As Long = &H808F
Public Const GL_COLOR_ARRAY_POINTER_EXT         As Long = &H8090
Public Const GL_INDEX_ARRAY_POINTER_EXT         As Long = &H8091
Public Const GL_TEXTURE_COORD_ARRAY_POINTER_EXT As Long = &H8092
Public Const GL_EDGE_FLAG_ARRAY_POINTER_EXT     As Long = &H8093

' EXT_bgra '
Public Const GL_BGR_EXT                         As Long = &H80E0&
Public Const GL_BGRA_EXT                        As Long = &H80E1&

' EXT_clip_volume_hint '
Public Const GL_CLIP_VOLUME_CLIPPING_HINT_EXT   As Long = &H80F0

' EXT_point_parameters '
Public Const GL_POINT_SIZE_MIN_EXT              As Long = &H8126
Public Const GL_POINT_SIZE_MAX_EXT              As Long = &H8127
Public Const GL_POINT_FADE_THRESHOLD_SIZE_EXT   As Long = &H8128
Public Const GL_DISTANCE_ATTENUATION_EXT        As Long = &H8129&

' EXT_compiled_vertex_array '
Public Const GL_ARRAY_ELEMENT_LOCK_FIRST_EXT    As Long = &H81A8
Public Const GL_ARRAY_ELEMENT_LOCK_COUNT_EXT    As Long = &H81A9

' EXT_cull_vertex '
Public Const GL_CULL_VERTEX_EXT                 As Long = &H81AA
Public Const GL_CULL_VERTEX_EYE_POSITION_EXT    As Long = &H81AB
Public Const GL_CULL_VERTEX_OBJECT_POSITION_EXT As Long = &H81AC

' ARB_multitexture '
Public Const GL_ACTIVE_TEXTURE_ARB              As Long = &H84E0&
Public Const GL_CLIENT_ACTIVE_TEXTURE_ARB       As Long = &H84E1&
Public Const GL_MAX_TEXTURE_UNITS_ARB           As Long = &H84E2&
Public Const GL_ACTIVE_TEXTURE                  As Long = &H84E0&
Public Const GL_TEXTURE0_ARB                    As Long = &H84C0& ' El estupido signo al final es necesario
Public Const GL_TEXTURE1_ARB                    As Long = &H84C1& ' para utilizar las funciones ARB
Public Const GL_TEXTURE2_ARB                    As Long = &H84C2&
Public Const GL_TEXTURE3_ARB                    As Long = &H84C3&
Public Const GL_TEXTURE4_ARB                    As Long = &H84C4&
Public Const GL_TEXTURE5_ARB                    As Long = &H84C5&
Public Const GL_TEXTURE6_ARB                    As Long = &H84C6&
Public Const GL_TEXTURE7_ARB                    As Long = &H84C7&
Public Const GL_TEXTURE8_ARB                    As Long = &H84C8&
Public Const GL_TEXTURE9_ARB                    As Long = &H84C9&
Public Const GL_TEXTURE10_ARB                   As Long = &H84CA&
Public Const GL_TEXTURE11_ARB                   As Long = &H84CB&
Public Const GL_TEXTURE12_ARB As Long = &H84CC&
Public Const GL_TEXTURE13_ARB As Long = &H84CD&
Public Const GL_TEXTURE14_ARB As Long = &H84CE&
Public Const GL_TEXTURE15_ARB As Long = &H84CF&
Public Const GL_TEXTURE16_ARB As Long = &H84D0&
Public Const GL_TEXTURE17_ARB As Long = &H84D1&
Public Const GL_TEXTURE18_ARB As Long = &H84D2&
Public Const GL_TEXTURE19_ARB As Long = &H84D3&
Public Const GL_TEXTURE20_ARB As Long = &H84D4&
Public Const GL_TEXTURE21_ARB As Long = &H84D5&
Public Const GL_TEXTURE22_ARB As Long = &H84D6&
Public Const GL_TEXTURE23_ARB As Long = &H84D7&
Public Const GL_TEXTURE24_ARB As Long = &H84D8&
Public Const GL_TEXTURE25_ARB As Long = &H84D9&
Public Const GL_TEXTURE26_ARB As Long = &H84DA&
Public Const GL_TEXTURE27_ARB As Long = &H84DB&
Public Const GL_TEXTURE28_ARB As Long = &H84DC&
Public Const GL_TEXTURE29_ARB As Long = &H84DD&
Public Const GL_TEXTURE30_ARB As Long = &H84DE&
Public Const GL_TEXTURE31_ARB As Long = &H84DF&

' EXT_stencil_wrap '
Public Const GL_INCR_WRAP_EXT As Long = &H8507
Public Const GL_DECR_WRAP_EXT As Long = &H8508

' NV_texgen_reflection '
Public Const GL_NORMAL_MAP_NV As Long = &H8511
Public Const GL_REFLECTION_MAP_NV As Long = &H8512

' EXT_texture_env_combine '
Public Const GL_COMBINE_EXT As Long = &H8570&
Public Const GL_COMBINE_RGB_EXT As Long = &H8571&
Public Const GL_COMBINE_ALPHA_EXT As Long = &H8572&
Public Const GL_RGB_SCALE_EXT As Long = &H8573&
Public Const GL_ADD_SIGNED_EXT As Long = &H8574&
Public Const GL_INTERPOLATE_EXT As Long = &H8575&
Public Const GL_CONSTANT_EXT As Long = &H8576&
Public Const GL_PRIMARY_COLOR_EXT As Long = &H8577&
Public Const GL_PREVIOUS_EXT As Long = &H8578&
Public Const GL_SOURCE0_RGB_EXT As Long = &H8580&
Public Const GL_SOURCE1_RGB_EXT As Long = &H8581&
Public Const GL_SOURCE2_RGB_EXT As Long = &H8582&
Public Const GL_SOURCE0_ALPHA_EXT As Long = &H8588
Public Const GL_SOURCE1_ALPHA_EXT As Long = &H8589
Public Const GL_SOURCE2_ALPHA_EXT As Long = &H858A
Public Const GL_OPERAND0_RGB_EXT As Long = &H8590
Public Const GL_OPERAND1_RGB_EXT As Long = &H8591
Public Const GL_OPERAND2_RGB_EXT As Long = &H8592
Public Const GL_OPERAND0_ALPHA_EXT As Long = &H8598
Public Const GL_OPERAND1_ALPHA_EXT As Long = &H8599
Public Const GL_OPERAND2_ALPHA_EXT As Long = &H859A

' NV_texture_env_combine4 '
Public Const GL_COMBINE4_NV As Long = &H8503
Public Const GL_SOURCE3_RGB_NV As Long = &H8583
Public Const GL_SOURCE3_ALPHA_NV As Long = &H858B
Public Const GL_OPERAND3_RGB_NV As Long = &H8593
Public Const GL_OPERAND3_ALPHA_NV As Long = &H859B

Public Const GL_CLAMP_TO_EDGE As Long = &H812F&
Public Const GL_CLAMP_TO_BORDER_ARB As Long = &H812D&
Public Const GL_COMPRESSED_RGB_ARB As Long = &H84ED&
Public Const GL_COMPRESSED_RGBA_ARB As Long = &H84EE&
Public Const GL_GENERATE_MIPMAP_SGIS As Long = &H8191&
Public Const GL_GENERATE_MIPMAP_HINT_SGIS As Long = &H8192&

Public Const GL_VERTEX_SHADER_ARB As Long = &H8B31&
Public Const GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB As Long = &H8B4A&
Public Const GL_MAX_VARYING_FLOATS_ARB As Long = &H8B4B&
Public Const GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB As Long = &H8B4C&
Public Const GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB As Long = &H8B4D&
Public Const GL_OBJECT_ACTIVE_ATTRIBUTES_ARB As Long = &H8B89&
Public Const GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB As Long = &H8B8A&

Public Const GL_PROGRAM_OBJECT_ARB As Long = &H8B40&
Public Const GL_SHADER_OBJECT_ARB As Long = &H8B48&
Public Const GL_OBJECT_TYPE_ARB As Long = &H8B4E&
Public Const GL_OBJECT_SUBTYPE_ARB As Long = &H8B4F&
Public Const GL_FLOAT_VEC2_ARB As Long = &H8B50&
Public Const GL_FLOAT_VEC3_ARB As Long = &H8B51&
Public Const GL_FLOAT_VEC4_ARB As Long = &H8B52&
Public Const GL_INT_VEC2_ARB As Long = &H8B53&
Public Const GL_INT_VEC3_ARB As Long = &H8B54&
Public Const GL_INT_VEC4_ARB As Long = &H8B55&
Public Const GL_BOOL_ARB As Long = &H8B56&
Public Const GL_BOOL_VEC2_ARB As Long = &H8B57&
Public Const GL_BOOL_VEC3_ARB As Long = &H8B58&
Public Const GL_BOOL_VEC4_ARB As Long = &H8B59&
Public Const GL_FLOAT_MAT2_ARB As Long = &H8B5A&
Public Const GL_FLOAT_MAT3_ARB As Long = &H8B5B&
Public Const GL_FLOAT_MAT4_ARB As Long = &H8B5C&
Public Const GL_SAMPLER_1D_ARB As Long = &H8B5D&
Public Const GL_SAMPLER_2D_ARB As Long = &H8B5E&
Public Const GL_SAMPLER_3D_ARB As Long = &H8B5F&
Public Const GL_SAMPLER_CUBE_ARB As Long = &H8B60&
Public Const GL_SAMPLER_1D_SHADOW_ARB As Long = &H8B61&
Public Const GL_SAMPLER_2D_SHADOW_ARB As Long = &H8B62&
Public Const GL_SAMPLER_2D_RECT_ARB As Long = &H8B63&
Public Const GL_SAMPLER_2D_RECT_SHADOW_ARB As Long = &H8B64&
Public Const GL_OBJECT_DELETE_STATUS_ARB As Long = &H8B80&
Public Const GL_OBJECT_COMPILE_STATUS_ARB As Long = &H8B81&
Public Const GL_OBJECT_LINK_STATUS_ARB As Long = &H8B82&
Public Const GL_OBJECT_VALIDATE_STATUS_ARB As Long = &H8B83&
Public Const GL_OBJECT_INFO_LOG_LENGTH_ARB As Long = &H8B84&
Public Const GL_OBJECT_ATTACHED_OBJECTS_ARB As Long = &H8B85&
Public Const GL_OBJECT_ACTIVE_UNIFORMS_ARB As Long = &H8B86&
Public Const GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB As Long = &H8B87&
Public Const GL_OBJECT_SHADER_SOURCE_LENGTH_ARB As Long = &H8B88&

Public Const GL_FRAGMENT_SHADER_ARB As Long = &H8B30&
Public Const GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB As Long = &H8B49&
Public Const GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB As Long = &H8B8B&

Public Const GL_TEXTURE_MAX_ANISOTROPY_EXT As Long = &H84FE&
Public Const GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT As Long = &H84FF&

Public Const GL_NORMAL_MAP As Long = &H8511&
Public Const GL_REFLECTION_MAP_ARB As Long = &H8512&
Public Const GL_TEXTURE_CUBE_MAP_ARB As Long = &H8513&
Public Const GL_TEXTURE_BINDING_CUBE_MAP_ARB As Long = &H8514&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB As Long = &H8515&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB As Long = &H8516&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB As Long = &H8517&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB As Long = &H8518&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB As Long = &H8519&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB As Long = &H851A&
Public Const GL_PROXY_TEXTURE_CUBE_MAP_ARB As Long = &H851B&
Public Const GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB As Long = &H851C&

Public Const GL_TEXTURE_WRAP_R As Long = &H8072&

Public Const GL_COMBINE_ARB As Long = &H8570&
Public Const GL_COMBINE_RGB_ARB As Long = &H8571&
Public Const GL_COMBINE_ALPHA_ARB As Long = &H8572&
Public Const GL_SOURCE0_RGB_ARB As Long = &H8580&
Public Const GL_SOURCE1_RGB_ARB As Long = &H8581&
Public Const GL_SOURCE2_RGB_ARB As Long = &H8582&
Public Const GL_SOURCE0_ALPHA_ARB As Long = &H8588&
Public Const GL_SOURCE1_ALPHA_ARB As Long = &H8589&
Public Const GL_SOURCE2_ALPHA_ARB As Long = &H858A&
Public Const GL_OPERAND0_RGB_ARB As Long = &H8590&
Public Const GL_OPERAND1_RGB_ARB As Long = &H8591&
Public Const GL_OPERAND2_RGB_ARB As Long = &H8592&
Public Const GL_OPERAND0_ALPHA_ARB As Long = &H8598&
Public Const GL_OPERAND1_ALPHA_ARB As Long = &H8599&
Public Const GL_OPERAND2_ALPHA_ARB As Long = &H859A&
Public Const GL_RGB_SCALE_ARB As Long = &H8573&
Public Const GL_ADD_SIGNED_ARB As Long = &H8574&
Public Const GL_INTERPOLATE_ARB As Long = &H8575&
Public Const GL_SUBTRACT_ARB As Long = &H84E7&
Public Const GL_CONSTANT_ARB As Long = &H8576&
Public Const GL_PRIMARY_COLOR_ARB As Long = &H8577&
Public Const GL_PREVIOUS_ARB As Long = &H8578&

Public Const GL_DOT3_RGB_ARB As Long = &H86AE&
Public Const GL_DOT3_RGBA_ARB As Long = &H86AF&

Public Const GL_TEXTURE_3D_EXT As Long = &H806F&

Public Const GL_DOT3_RGB_EXT As Long = &H8740&
Public Const GL_DOT3_RGBA_EXT As Long = &H8741&

Public Const GL_NORMAL_MAP_EXT As Long = &H8511&
Public Const GL_REFLECTION_MAP_EXT As Long = &H8512&
Public Const GL_TEXTURE_CUBE_MAP_EXT As Long = &H8513&
Public Const GL_TEXTURE_BINDING_CUBE_MAP_EXT As Long = &H8514&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT As Long = &H8515&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT As Long = &H8516&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT As Long = &H8517&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT As Long = &H8518&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT As Long = &H8519&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT As Long = &H851A&
Public Const GL_PROXY_TEXTURE_CUBE_MAP_EXT As Long = &H851B&
Public Const GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT As Long = &H851C&

Public Const GL_ARRAY_BUFFER_ARB As Long = &H8892&
Public Const GL_READ_ONLY_ARB As Long = &H88B8&
Public Const GL_WRITE_ONLY_ARB As Long = &H88B9&
Public Const GL_READ_WRITE_ARB As Long = &H88BA&
Public Const GL_BUFFER_ACCESS_ARB As Long = &H88BB&
Public Const GL_BUFFER_MAPPED_ARB As Long = &H88BC&
Public Const GL_BUFFER_MAP_POINTER_ARB As Long = &H88BD&
Public Const GL_STREAM_DRAW_ARB As Long = &H88E0&
Public Const GL_STREAM_READ_ARB As Long = &H88E1&
Public Const GL_STREAM_COPY_ARB As Long = &H88E2&
Public Const GL_STATIC_DRAW_ARB As Long = &H88E4&
Public Const GL_STATIC_READ_ARB As Long = &H88E5&
Public Const GL_STATIC_COPY_ARB As Long = &H88E6&
Public Const GL_DYNAMIC_DRAW_ARB As Long = &H88E8&
Public Const GL_DYNAMIC_READ_ARB As Long = &H88E9&
Public Const GL_DYNAMIC_COPY_ARB As Long = &H88EA&

Public Const GL_VERSION_1_3 As Long = 1

Public Const GL_MULTISAMPLE As Long = &H809D&
Public Const GL_SAMPLE_ALPHA_TO_COVERAGE As Long = &H809E&
Public Const GL_SAMPLE_ALPHA_TO_ONE As Long = &H809F&
Public Const GL_SAMPLE_COVERAGE As Long = &H80A0&
Public Const GL_SAMPLE_BUFFERS As Long = &H80A8&
Public Const GL_SAMPLES As Long = &H80A9&
Public Const GL_SAMPLE_COVERAGE_VALUE As Long = &H80AA&
Public Const GL_SAMPLE_COVERAGE_INVERT As Long = &H80AB&
Public Const GL_CLAMP_TO_BORDER As Long = &H812D&
Public Const GL_TEXTURE0 As Long = &H84C0&
Public Const GL_TEXTURE1 As Long = &H84C1&
Public Const GL_TEXTURE2 As Long = &H84C2&
Public Const GL_TEXTURE3 As Long = &H84C3&
Public Const GL_TEXTURE4 As Long = &H84C4&
Public Const GL_TEXTURE5 As Long = &H84C5&
Public Const GL_TEXTURE6 As Long = &H84C6&
Public Const GL_TEXTURE7 As Long = &H84C7&
Public Const GL_TEXTURE8 As Long = &H84C8&
Public Const GL_TEXTURE9 As Long = &H84C9&
Public Const GL_TEXTURE10 As Long = &H84CA&
Public Const GL_TEXTURE11 As Long = &H84CB&
Public Const GL_TEXTURE12 As Long = &H84CC&
Public Const GL_TEXTURE13 As Long = &H84CD&
Public Const GL_TEXTURE14 As Long = &H84CE&
Public Const GL_TEXTURE15 As Long = &H84CF&
Public Const GL_TEXTURE16 As Long = &H84D0&
Public Const GL_TEXTURE17 As Long = &H84D1&
Public Const GL_TEXTURE18 As Long = &H84D2&
Public Const GL_TEXTURE19 As Long = &H84D3&
Public Const GL_TEXTURE20 As Long = &H84D4&
Public Const GL_TEXTURE21 As Long = &H84D5&
Public Const GL_TEXTURE22 As Long = &H84D6&
Public Const GL_TEXTURE23 As Long = &H84D7&
Public Const GL_TEXTURE24 As Long = &H84D8&
Public Const GL_TEXTURE25 As Long = &H84D9&
Public Const GL_TEXTURE26 As Long = &H84DA&
Public Const GL_TEXTURE27 As Long = &H84DB&
Public Const GL_TEXTURE28 As Long = &H84DC&
Public Const GL_TEXTURE29 As Long = &H84DD&
Public Const GL_TEXTURE30 As Long = &H84DE&
Public Const GL_TEXTURE31 As Long = &H84DF&
Public Const GL_CLIENT_ACTIVE_TEXTURE As Long = &H84E1&
Public Const GL_MAX_TEXTURE_UNITS As Long = &H84E2&
Public Const GL_TRANSPOSE_MODELVIEW_MATRIX As Long = &H84E3&
Public Const GL_TRANSPOSE_PROJECTION_MATRIX As Long = &H84E4&
Public Const GL_TRANSPOSE_TEXTURE_MATRIX As Long = &H84E5&
Public Const GL_TRANSPOSE_COLOR_MATRIX As Long = &H84E6&
Public Const GL_SUBTRACT As Long = &H84E7&
Public Const GL_COMPRESSED_ALPHA As Long = &H84E9&
Public Const GL_COMPRESSED_LUMINANCE As Long = &H84EA&
Public Const GL_COMPRESSED_LUMINANCE_ALPHA As Long = &H84EB&
Public Const GL_COMPRESSED_INTENSITY As Long = &H84EC&
Public Const GL_COMPRESSED_RGB As Long = &H84ED&
Public Const GL_COMPRESSED_RGBA As Long = &H84EE&
Public Const GL_TEXTURE_COMPRESSION_HINT As Long = &H84EF&
Public Const GL_REFLECTION_MAP As Long = &H8512&
Public Const GL_TEXTURE_CUBE_MAP As Long = &H8513&
Public Const GL_TEXTURE_BINDING_CUBE_MAP As Long = &H8514&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_X As Long = &H8515&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_X As Long = &H8516&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_Y As Long = &H8517&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_Y As Long = &H8518&
Public Const GL_TEXTURE_CUBE_MAP_POSITIVE_Z As Long = &H8519&
Public Const GL_TEXTURE_CUBE_MAP_NEGATIVE_Z As Long = &H851A&
Public Const GL_PROXY_TEXTURE_CUBE_MAP As Long = &H851B&
Public Const GL_MAX_CUBE_MAP_TEXTURE_SIZE As Long = &H851C&
Public Const GL_COMBINE As Long = &H8570&
Public Const GL_COMBINE_RGB As Long = &H8571&
Public Const GL_COMBINE_ALPHA As Long = &H8572&
Public Const GL_RGB_SCALE As Long = &H8573&
Public Const GL_ADD_SIGNED As Long = &H8574&
Public Const GL_INTERPOLATE As Long = &H8575&
Public Const GL_CONSTANT As Long = &H8576&
Public Const GL_PRIMARY_COLOR As Long = &H8577&
Public Const GL_PREVIOUS As Long = &H8578&
Public Const GL_SOURCE0_RGB As Long = &H8580&
Public Const GL_SOURCE1_RGB As Long = &H8581&
Public Const GL_SOURCE2_RGB As Long = &H8582&
Public Const GL_SOURCE0_ALPHA As Long = &H8588&
Public Const GL_SOURCE1_ALPHA As Long = &H8589&
Public Const GL_SOURCE2_ALPHA As Long = &H858A&
Public Const GL_OPERAND0_RGB As Long = &H8590&
Public Const GL_OPERAND1_RGB As Long = &H8591&
Public Const GL_OPERAND2_RGB As Long = &H8592&
Public Const GL_OPERAND0_ALPHA As Long = &H8598&
Public Const GL_OPERAND1_ALPHA As Long = &H8599&
Public Const GL_OPERAND2_ALPHA As Long = &H859A&
Public Const GL_TEXTURE_COMPRESSED_IMAGE_SIZE As Long = &H86A0&
Public Const GL_TEXTURE_COMPRESSED As Long = &H86A1&
Public Const GL_NUM_COMPRESSED_TEXTURE_FORMATS As Long = &H86A2&
Public Const GL_COMPRESSED_TEXTURE_FORMATS As Long = &H86A3&
Public Const GL_DOT3_RGB As Long = &H86AE&
Public Const GL_DOT3_RGBA As Long = &H86AF&
Public Const GL_MULTISAMPLE_BIT As Long = &H20000000

Public Const GL_VERSION_1_4 As Long = 1

Public Const GL_BLEND_DST_RGB As Long = &H80C8&
Public Const GL_BLEND_SRC_RGB As Long = &H80C9&
Public Const GL_BLEND_DST_ALPHA As Long = &H80CA&
Public Const GL_BLEND_SRC_ALPHA As Long = &H80CB&
Public Const GL_POINT_SIZE_MIN As Long = &H8126&
Public Const GL_POINT_SIZE_MAX As Long = &H8127&
Public Const GL_POINT_FADE_THRESHOLD_SIZE As Long = &H8128&
Public Const GL_POINT_DISTANCE_ATTENUATION As Long = &H8129&
Public Const GL_GENERATE_MIPMAP As Long = &H8191&
Public Const GL_GENERATE_MIPMAP_HINT As Long = &H8192&
Public Const GL_DEPTH_COMPONENT16 As Long = &H81A5&
Public Const GL_DEPTH_COMPONENT24 As Long = &H81A6&
Public Const GL_DEPTH_COMPONENT32 As Long = &H81A7&
Public Const GL_MIRRORED_REPEAT As Long = &H8370&
Public Const GL_FOG_COORDINATE_SOURCE As Long = &H8450&
Public Const GL_FOG_COORDINATE As Long = &H8451&
Public Const GL_FRAGMENT_DEPTH As Long = &H8452&
Public Const GL_CURRENT_FOG_COORDINATE As Long = &H8453&
Public Const GL_FOG_COORDINATE_ARRAY_TYPE As Long = &H8454&
Public Const GL_FOG_COORDINATE_ARRAY_STRIDE As Long = &H8455&
Public Const GL_FOG_COORDINATE_ARRAY_POINTER As Long = &H8456&
Public Const GL_FOG_COORDINATE_ARRAY As Long = &H8457&
Public Const GL_COLOR_SUM As Long = &H8458&
Public Const GL_CURRENT_SECONDARY_COLOR As Long = &H8459&
Public Const GL_SECONDARY_COLOR_ARRAY_SIZE As Long = &H845A&
Public Const GL_SECONDARY_COLOR_ARRAY_TYPE As Long = &H845B&
Public Const GL_SECONDARY_COLOR_ARRAY_STRIDE As Long = &H845C&
Public Const GL_SECONDARY_COLOR_ARRAY_POINTER As Long = &H845D&
Public Const GL_SECONDARY_COLOR_ARRAY As Long = &H845E&
Public Const GL_MAX_TEXTURE_LOD_BIAS As Long = &H84FD&
Public Const GL_TEXTURE_FILTER_CONTROL As Long = &H8500&
Public Const GL_TEXTURE_LOD_BIAS As Long = &H8501&
Public Const GL_INCR_WRAP As Long = &H8507&
Public Const GL_DECR_WRAP As Long = &H8508&
Public Const GL_TEXTURE_DEPTH_SIZE As Long = &H884A&
Public Const GL_DEPTH_TEXTURE_MODE As Long = &H884B&
Public Const GL_TEXTURE_COMPARE_MODE As Long = &H884C&
Public Const GL_TEXTURE_COMPARE_FUNC As Long = &H884D&
Public Const GL_COMPARE_R_TO_TEXTURE As Long = &H884E&

Public Const GL_VERSION_1_5 As Long = 1

Public Const GL_FOG_COORD_SRC As Long = GL_FOG_COORDINATE_SOURCE
Public Const GL_FOG_COORD As Long = GL_FOG_COORDINATE
Public Const GL_FOG_COORD_ARRAY As Long = GL_FOG_COORDINATE_ARRAY
Public Const GL_SRC0_RGB As Long = GL_SOURCE0_RGB
Public Const GL_FOG_COORD_ARRAY_POINTER As Long = GL_FOG_COORDINATE_ARRAY_POINTER
Public Const GL_FOG_COORD_ARRAY_TYPE As Long = GL_FOG_COORDINATE_ARRAY_TYPE
Public Const GL_SRC1_ALPHA As Long = GL_SOURCE1_ALPHA
Public Const GL_CURRENT_FOG_COORD As Long = GL_CURRENT_FOG_COORDINATE
Public Const GL_FOG_COORD_ARRAY_STRIDE As Long = GL_FOG_COORDINATE_ARRAY_STRIDE
Public Const GL_SRC0_ALPHA As Long = GL_SOURCE0_ALPHA
Public Const GL_SRC1_RGB As Long = GL_SOURCE1_RGB
Public Const GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING As Long = &H889D&
Public Const GL_FOG_COORD_ARRAY_BUFFER_BINDING As Long = GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING
Public Const GL_SRC2_ALPHA As Long = GL_SOURCE2_ALPHA
Public Const GL_SRC2_RGB As Long = GL_SOURCE2_RGB
Public Const GL_BUFFER_SIZE As Long = &H8764&
Public Const GL_BUFFER_USAGE As Long = &H8765&
Public Const GL_QUERY_COUNTER_BITS As Long = &H8864&
Public Const GL_CURRENT_QUERY As Long = &H8865&
Public Const GL_QUERY_RESULT As Long = &H8866&
Public Const GL_QUERY_RESULT_AVAILABLE As Long = &H8867&
Public Const GL_ARRAY_BUFFER As Long = &H8892&
Public Const GL_ELEMENT_ARRAY_BUFFER As Long = &H8893&
Public Const GL_ARRAY_BUFFER_BINDING As Long = &H8894&
Public Const GL_ELEMENT_ARRAY_BUFFER_BINDING As Long = &H8895&
Public Const GL_VERTEX_ARRAY_BUFFER_BINDING As Long = &H8896&
Public Const GL_NORMAL_ARRAY_BUFFER_BINDING As Long = &H8897&
Public Const GL_COLOR_ARRAY_BUFFER_BINDING As Long = &H8898&
Public Const GL_INDEX_ARRAY_BUFFER_BINDING As Long = &H8899&
Public Const GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING As Long = &H889A&
Public Const GL_EDGE_FLAG_ARRAY_BUFFER_BINDING As Long = &H889B&
Public Const GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING As Long = &H889C&
Public Const GL_WEIGHT_ARRAY_BUFFER_BINDING As Long = &H889E&
Public Const GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING As Long = &H889F&
Public Const GL_READ_ONLY As Long = &H88B8&
Public Const GL_WRITE_ONLY As Long = &H88B9&
Public Const GL_READ_WRITE As Long = &H88BA&
Public Const GL_BUFFER_ACCESS As Long = &H88BB&
Public Const GL_BUFFER_MAPPED As Long = &H88BC&
Public Const GL_BUFFER_MAP_POINTER As Long = &H88BD&
Public Const GL_STREAM_DRAW As Long = &H88E0&
Public Const GL_STREAM_READ As Long = &H88E1&
Public Const GL_STREAM_COPY As Long = &H88E2&
Public Const GL_STATIC_DRAW As Long = &H88E4&
Public Const GL_STATIC_READ As Long = &H88E5&
Public Const GL_STATIC_COPY As Long = &H88E6&
Public Const GL_DYNAMIC_DRAW As Long = &H88E8&
Public Const GL_DYNAMIC_READ As Long = &H88E9&
Public Const GL_DYNAMIC_COPY As Long = &H88EA&
Public Const GL_SAMPLES_PASSED As Long = &H8914&

Public Const WGL_SAMPLE_BUFFERS_ARB         As Long = &H2041&
Public Const WGL_SAMPLES_ARB                As Long = &H2042&

Public Const WGL_DRAW_TO_WINDOW_ARB    As Long = &H2001&
Public Const WGL_SUPPORT_OPENGL_ARB    As Long = &H2010&
Public Const WGL_ACCELERATION_ARB      As Long = &H2003&
Public Const WGL_FULL_ACCELERATION_ARB As Long = &H2027&
Public Const WGL_COLOR_BITS_ARB        As Long = &H2014&
Public Const WGL_ALPHA_BITS_ARB        As Long = &H201B&
Public Const WGL_DEPTH_BITS_ARB        As Long = &H2022&
Public Const WGL_STENCIL_BITS_ARB      As Long = &H2023&
Public Const WGL_DOUBLE_BUFFER_ARB     As Long = &H2011&

Public Const GL_COMPRESSED_RGB_S3TC_DXT1_EXT  As Long = &H83F0&
Public Const GL_COMPRESSED_RGBA_S3TC_DXT1_EXT As Long = &H83F1&
Public Const GL_COMPRESSED_RGBA_S3TC_DXT3_EXT As Long = &H83F2&
Public Const GL_COMPRESSED_RGBA_S3TC_DXT5_EXT As Long = &H83F3&

Public Const GL_GLEXT_VERSION                   As Long = 39&
Public Const GL_UNSIGNED_BYTE_3_3_2             As Long = &H8032&
Public Const GL_UNSIGNED_SHORT_4_4_4_4          As Long = &H8033&
Public Const GL_UNSIGNED_SHORT_5_5_5_1          As Long = &H8034&
Public Const GL_UNSIGNED_INT_8_8_8_8            As Long = &H8035&
Public Const GL_UNSIGNED_INT_10_10_10_2         As Long = &H8036&
Public Const GL_RESCALE_NORMAL                  As Long = &H803A&
Public Const GL_TEXTURE_BINDING_3D              As Long = &H806A&
Public Const GL_PACK_SKIP_IMAGES                As Long = &H806B&
Public Const GL_PACK_IMAGE_HEIGHT               As Long = &H806C&
Public Const GL_UNPACK_SKIP_IMAGES              As Long = &H806D&
Public Const GL_UNPACK_IMAGE_HEIGHT             As Long = &H806E&
Public Const GL_TEXTURE_3D                      As Long = &H806F&
Public Const GL_PROXY_TEXTURE_3D                As Long = &H8070&
Public Const GL_TEXTURE_DEPTH                   As Long = &H8071&
Public Const GL_MAX_3D_TEXTURE_SIZE             As Long = &H8073&
Public Const GL_UNSIGNED_BYTE_2_3_3_REV         As Long = &H8362&
Public Const GL_UNSIGNED_SHORT_5_6_5            As Long = &H8363&
Public Const GL_UNSIGNED_SHORT_5_6_5_REV        As Long = &H8364&
Public Const GL_UNSIGNED_SHORT_4_4_4_4_REV      As Long = &H8365&
Public Const GL_UNSIGNED_SHORT_1_5_5_5_REV      As Long = &H8366&
Public Const GL_UNSIGNED_INT_8_8_8_8_REV        As Long = &H8367&
Public Const GL_UNSIGNED_INT_2_10_10_10_REV     As Long = &H8368&
Public Const GL_BGR                             As Long = &H80E0&
Public Const GL_BGRA                            As Long = &H80E1&
Public Const GL_MAX_ELEMENTS_VERTICES           As Long = &H80E8&
Public Const GL_MAX_ELEMENTS_INDICES            As Long = &H80E9&
Public Const GL_TEXTURE_MIN_LOD                 As Long = &H813A&
Public Const GL_TEXTURE_MAX_LOD                 As Long = &H813B&
Public Const GL_TEXTURE_BASE_LEVEL              As Long = &H813C&
Public Const GL_TEXTURE_MAX_LEVEL               As Long = &H813D&
Public Const GL_LIGHT_MODEL_COLOR_CONTROL       As Long = &H81F8&
Public Const GL_SINGLE_COLOR                    As Long = &H81F9&
Public Const GL_SEPARATE_SPECULAR_COLOR         As Long = &H81FA&
Public Const GL_SMOOTH_POINT_SIZE_RANGE         As Long = &HB12&
Public Const GL_SMOOTH_POINT_SIZE_GRANULARITY   As Long = &HB13&
Public Const GL_SMOOTH_LINE_WIDTH_RANGE         As Long = &HB22&
Public Const GL_SMOOTH_LINE_WIDTH_GRANULARITY   As Long = &HB23&
Public Const GL_ALIASED_POINT_SIZE_RANGE        As Long = &H846D&
Public Const GL_ALIASED_LINE_WIDTH_RANGE        As Long = &H846E&

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes As Long)
Private mlngParameters() As Long 'list of parameters
Private mlngAddress      As Long 'address of function to call
Private mbytCode()       As Byte 'buffer for assembly code
Private mlngCP           As Long 'used to keep track of latest byte added to code


Public arbMultisampleSupported              As Boolean
Public arbMultisampleFormat                 As Long

'If you don't want multisampling, set this to 0
Public Const CHECK_FOR_MULTISAMPLE   As Long = &H0&

Public clsARB                        As New ClsGLext_ARB
Private pClientActiveTexture         As Long

Public Sub InitEx()
    pClientActiveTexture = wglGetProcAddress("glClientActiveTexture")
End Sub

Public Function getGlExtensions() As String
    Dim OpenGLExtensions As String
    Dim lngPtrExtensions As Long
    Dim bytTmp As Byte, lngIdx As Long
    '--- Get Extensions
    lngPtrExtensions = glGetString(szExtensions)
    lngIdx = 0
    Do
       CopyMemory bytTmp, ByVal lngPtrExtensions + lngIdx, 1
       If Chr(bytTmp) = vbNullChar _
          Then
              Exit Do
          Else
              OpenGLExtensions = OpenGLExtensions & Chr(bytTmp)
              lngIdx = lngIdx + 1
       End If
    Loop
    getGlExtensions = Replace(OpenGLExtensions, Chr(32), vbCrLf)
End Function

Public Function ExtensionSupported(extension As String) As Boolean
    Dim extlen           As Long
    Dim supported        As Long
    Dim OpenGLExtensions As String
    Dim bytTmp           As Byte
    Dim lngIdx           As Long
    lngIdx = 0
    
    supported = glGetString(GL_EXTENSIONS)
    
    If supported = 0 _
       Then
           Exit Function
    End If
    Do
       CopyMemory bytTmp, ByVal supported + lngIdx, 1
       If bytTmp = 0 _
          Then
              Exit Do
          Else
              OpenGLExtensions = OpenGLExtensions & Chr(bytTmp)
              lngIdx = lngIdx + 1
       End If
    Loop
    If InStr(1, " " & OpenGLExtensions & " ", " " & extension & " ") > 0 _
       Then
           ExtensionSupported = True
    End If
End Function

Public Function InitMultisample(hInstance As Long, hwnd As Long, hDC As Long, pfd As PIXELFORMATDESCRIPTOR) As Boolean
    ' InitMultisample: Used To Query The Multisample Frequencies
    Dim pixelFormat     As Long
    Dim valid           As Long
    Dim numFormats      As Long
    Dim fAttributes(21) As Single
    Dim iAttributes(21) As Long
    
    ' See If The String Exists In ARB!
    If Not ExtensionSupported("GL_ARB_multisample") _
       Then
           arbMultisampleSupported = False
           Exit Function
    End If
    ' Get Our Pixel Format
    If wglGetProcAddress("wglChoosePixelFormatARB") = 0 _
       Then
           arbMultisampleSupported = False
           Exit Function
    End If

    ' Get Our Current Device Context
    'hDC = GetDC(hWnd)
    
    ' These Attributes Are The Bits We Want To Test For In Our Sample
    ' Everything Is Pretty Standard, The Only One We Want To
    ' Really Focus On Is The SAMPLE BUFFERS ARB And WGL SAMPLES
    ' These Two Are Going To Do The Main Testing For Whether Or Not
    ' We Support Multisampling On This Hardware.
    
    iAttributes(0) = WGL_DRAW_TO_WINDOW_ARB
    iAttributes(1) = GL_TRUE
    
    iAttributes(2) = WGL_SUPPORT_OPENGL_ARB
    iAttributes(3) = GL_TRUE
    
    iAttributes(4) = WGL_ACCELERATION_ARB
    iAttributes(5) = WGL_FULL_ACCELERATION_ARB
    
    iAttributes(6) = WGL_COLOR_BITS_ARB
    iAttributes(7) = 24
    
    iAttributes(8) = WGL_ALPHA_BITS_ARB
    iAttributes(9) = 8
    
    iAttributes(10) = WGL_DEPTH_BITS_ARB
    iAttributes(11) = 16
    
    iAttributes(12) = WGL_STENCIL_BITS_ARB
    iAttributes(13) = 0
    
    iAttributes(14) = WGL_DOUBLE_BUFFER_ARB
    iAttributes(15) = GL_TRUE
    
    iAttributes(16) = WGL_SAMPLE_BUFFERS_ARB
    iAttributes(17) = GL_TRUE
    
    iAttributes(18) = WGL_SAMPLES_ARB
    iAttributes(19) = 4
    
    iAttributes(20) = 0
    iAttributes(21) = 0
    
    ' First We Check To See If We Can Get A Pixel Format For 4 Samples
    'valid = wglChoosePixelFormatARB(hDC, iAttributes(0), fAttributes(0), 1, pixelFormat, VarPtr(numFormats))
    valid = callGLExt("wglChoosePixelFormatARB", hDC, VarPtr(iAttributes(0)), VarPtr(fAttributes(0)), 1, VarPtr(pixelFormat), VarPtr(numFormats))
    
    'Once you have a context/drawable set up:
    'If fNVMultiSampleFilterHint _
    '   Then ' set this flag based on if
    '        ' GL_NV_multisample_filter_hint is supported
    '        ' glHint GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST
    'End If
    
    ' If We Returned True, And Our Format Count Is Greater Than 1
    If numFormats >= 1 _
       Then
           arbMultisampleSupported = True
           arbMultisampleFormat = pixelFormat
           InitMultisample = arbMultisampleSupported
           Exit Function
    End If

    ' Our Pixel Format With 4 Samples Failed, Test For 2 Samples
    iAttributes(19) = 2
    valid = callGLExt("wglChoosePixelFormatARB", hDC, VarPtr(iAttributes(0)), VarPtr(fAttributes(0)), 1, VarPtr(pixelFormat), VarPtr(numFormats))
    If valid And numFormats >= 1 _
       Then
           arbMultisampleSupported = True
           arbMultisampleFormat = pixelFormat
           InitMultisample = arbMultisampleSupported
           Exit Function
    End If
      
    ' Return The Valid Format
    InitMultisample = arbMultisampleSupported

End Function

Public Function callGLExt(funcName As String, ParamArray FuncParams()) As Long
   Dim lb As Long, i As Integer
   ReDim mlngParameters(0)
   ReDim mbytCode(0)
   mlngAddress = 0
   mlngAddress = wglGetProcAddress(funcName)
   If mlngAddress = 0 _
      Then
          MsgBox "Function entry not found", vbCritical
          Exit Function
   End If
   ReDim mlngParameters(UBound(FuncParams) + 1)
   For i = 1 To UBound(mlngParameters)
      mlngParameters(i) = CLng(FuncParams(i - 1))
   Next i
   callGLExt = CallWindowProc(PrepareCode, 0, 0, 0, 0)
End Function

Public Function callGLextPtr(ByVal funcPtr As Long, ParamArray FuncParams()) As Long
   Dim lb As Long, i As Integer
   ReDim mlngParameters(0)
   ReDim mbytCode(0)
   mlngAddress = 0
   mlngAddress = funcPtr
   ReDim mlngParameters(UBound(FuncParams) + 1)
   For i = 1 To UBound(mlngParameters)
      mlngParameters(i) = CLng(FuncParams(i - 1))
   Next i
   callGLextPtr = CallWindowProc(PrepareCode, 0, 0, 0, 0)
End Function

Private Function PrepareCode() As Long
    Dim lngX As Long, codeStart As Long
    ReDim mbytCode(18 + 32 + 6 * UBound(mlngParameters))
    codeStart = GetAlignedCodeStart(VarPtr(mbytCode(0)))
    mlngCP = codeStart - VarPtr(mbytCode(0))
    For lngX = 0 To mlngCP - 1
        mbytCode(lngX) = &HCC
    Next
    AddByteToCode &H58 'pop eax
    AddByteToCode &H59 'pop ecx
    AddByteToCode &H59 'pop ecx
    AddByteToCode &H59 'pop ecx
    AddByteToCode &H59 'pop ecx
    AddByteToCode &H50 'push eax
    For lngX = UBound(mlngParameters) To 1 Step -1
        AddByteToCode &H68 'push wwxxyyzz
        AddLongToCode mlngParameters(lngX)
    Next
    AddCallToCode mlngAddress
    AddByteToCode &HC3
    AddByteToCode &HCC
    PrepareCode = codeStart
End Function

Private Sub AddCallToCode(lngAddress As Long)
    AddByteToCode &HE8
    AddLongToCode lngAddress - VarPtr(mbytCode(mlngCP)) - 4
End Sub

Private Sub AddLongToCode(lng As Long)
    Dim intX As Integer
    Dim byt(3) As Byte
    CopyMemory byt(0), lng, 4
    For intX = 0 To 3
        AddByteToCode byt(intX)
    Next
End Sub

Private Sub AddByteToCode(byt As Byte)
    mbytCode(mlngCP) = byt
    mlngCP = mlngCP + 1
End Sub

Private Function GetAlignedCodeStart(lngAddress As Long) As Long
    GetAlignedCodeStart = lngAddress + (15 - (lngAddress - 1) Mod 16)
    If (15 - (lngAddress - 1) Mod 16) = 0 Then GetAlignedCodeStart = GetAlignedCodeStart + 16
End Function

Public Sub glLoadTransposeMatrixf(m As Single)
    Call clsARB.glLoadTransposeMatrixfARB(m)
End Sub

Public Sub glGenBuffers(ByVal n As Long, ByRef buffers As Long)
    Call clsARB.glGenBuffersARB(n, buffers)
End Sub

Public Sub glBindBuffer(ByVal target As Long, ByVal buffer As Long)
    Call clsARB.glBindBufferARB(target, buffer)
End Sub

Public Sub glBufferData(ByVal target As Long, ByVal size As Long, ByVal data As Long, ByVal usage As Long)
    Call clsARB.glBufferDataARB(target, size, data, usage)
End Sub

Public Sub glClientActiveTexture(ByVal texture As Long)
    'Call clsARB.glActiveTextureARB(texture) Doesn't work
    callGLextPtr pClientActiveTexture, texture
End Sub

Public Sub glActiveTexture(ByVal texture As Long)
    Call clsARB.glActiveTextureARB(texture)
End Sub

Public Sub glDeleteBuffers(ByVal n As Long, ByRef buffers As Long)
    Call clsARB.glDeleteBuffersARB(n, buffers)
End Sub

Public Sub glCompressedTexImage2D(ByVal target As Long, ByVal level As Long, ByVal internalformat As Long, ByVal width As Long, ByVal height As Long, ByVal border As Long, ByVal imageSize As Long, ByVal data As Long)
    Call clsARB.glCompressedTexImage2DARB(target, level, internalformat, width, height, border, imageSize, data)
End Sub
