Attribute VB_Name = "mdlMatVec"
Option Explicit

Public Sub Mprintg(m() As Double)
    LogToFile _
     m(0, 0) & ", " & m(0, 1) & ", " & m(0, 2) & vbCrLf & _
     m(1, 0) & ", " & m(1, 1) & ", " & m(1, 2) & vbCrLf & _
     m(2, 0) & ", " & m(2, 1) & ", " & m(2, 2)
End Sub

Public Sub Mfprint(f As Integer, m() As Double)
    LogToFile _
     m(0, 0) & ", " & m(0, 1) & ", " & m(0, 2) & vbCrLf & _
     m(1, 0) & ", " & m(1, 1) & ", " & m(1, 2) & vbCrLf & _
     m(2, 0) & ", " & m(2, 1) & ", " & m(2, 2), f
End Sub

Public Sub Mprint(m() As Double)
    LogToFile _
     m(0, 0) & ", " & m(0, 1) & ", " & m(0, 2) & vbCrLf & _
     m(1, 0) & ", " & m(1, 1) & ", " & m(1, 2) & vbCrLf & _
     m(2, 0) & ", " & m(2, 1) & ", " & m(2, 2)
End Sub

Public Sub Vprintg(V() As Double)
    LogToFile V(0) & ", " & V(1) & ", " & V(2)
End Sub

Public Sub Vfprint(f As Integer, V() As Double)
    LogToFile V(0) & ", " & V(1) & ", " & V(2), f
End Sub

Public Sub Vprint(V() As Double)
    LogToFile V(0) & ", " & V(1) & ", " & V(2)
End Sub

Public Sub Midentity(m() As Double)
    m(0, 0) = 1: m(0, 1) = 0: m(0, 2) = 0
    m(1, 0) = 0: m(1, 1) = 1: m(1, 2) = 0
    m(2, 0) = 0: m(2, 1) = 0: m(2, 2) = 1
End Sub

Public Sub McM(Mr() As Double, m() As Double)
    Mr(0, 0) = m(0, 0):  Mr(0, 1) = m(0, 1):  Mr(0, 2) = m(0, 2)
    Mr(1, 0) = m(1, 0):  Mr(1, 1) = m(1, 1):  Mr(1, 2) = m(1, 2)
    Mr(2, 0) = m(2, 0):  Mr(2, 1) = m(2, 1):  Mr(2, 2) = m(2, 2)
End Sub

Public Sub VcV(Vr() As Double, V() As Double)
    Vr(0) = V(0):  Vr(1) = V(1):  Vr(2) = V(2)
End Sub

Public Sub McolcV(Vr() As Double, m() As Double, c As Long)
    Vr(0) = m(0, c)
    Vr(1) = m(1, c)
    Vr(2) = m(2, c)
End Sub

Public Sub McolcMcol(Mr() As Double, cr As Long, m() As Double, c As Long)
    Mr(0, cr) = m(0, c)
    Mr(1, cr) = m(1, c)
    Mr(2, cr) = m(2, c)
End Sub

Public Sub MxMpV(Mr() As Double, M1() As Double, M2() As Double, T() As Double)
    Mr(0, 0) = (M1(0, 0) * M2(0, 0) + _
            M1(0, 1) * M2(1, 0) + _
            M1(0, 2) * M2(2, 0) + _
            T(0))
    Mr(1, 0) = (M1(1, 0) * M2(0, 0) + _
            M1(1, 1) * M2(1, 0) + _
            M1(1, 2) * M2(2, 0) + _
            T(1))
    Mr(2, 0) = (M1(2, 0) * M2(0, 0) + _
            M1(2, 1) * M2(1, 0) + _
            M1(2, 2) * M2(2, 0) + _
            T(2))
    Mr(0, 1) = (M1(0, 0) * M2(0, 1) + _
            M1(0, 1) * M2(1, 1) + _
            M1(0, 2) * M2(2, 1) + _
            T(0))
    Mr(1, 1) = (M1(1, 0) * M2(0, 1) + _
            M1(1, 1) * M2(1, 1) + _
            M1(1, 2) * M2(2, 1) + _
            T(1))
    Mr(2, 1) = (M1(2, 0) * M2(0, 1) + _
            M1(2, 1) * M2(1, 1) + _
            M1(2, 2) * M2(2, 1) + _
            T(2))
    Mr(0, 2) = (M1(0, 0) * M2(0, 2) + _
            M1(0, 1) * M2(1, 2) + _
            M1(0, 2) * M2(2, 2) + _
            T(0))
    Mr(1, 2) = (M1(1, 0) * M2(0, 2) + _
            M1(1, 1) * M2(1, 2) + _
            M1(1, 2) * M2(2, 2) + _
            T(1))
    Mr(2, 2) = (M1(2, 0) * M2(0, 2) + _
            M1(2, 1) * M2(1, 2) + _
            M1(2, 2) * M2(2, 2) + _
            T(2))
End Sub

Public Sub MxM(Mr() As Double, M1() As Double, M2() As Double)
    Mr(0, 0) = (M1(0, 0) * M2(0, 0) + _
            M1(0, 1) * M2(1, 0) + _
            M1(0, 2) * M2(2, 0))
    Mr(1, 0) = (M1(1, 0) * M2(0, 0) + _
            M1(1, 1) * M2(1, 0) + _
            M1(1, 2) * M2(2, 0))
    Mr(2, 0) = (M1(2, 0) * M2(0, 0) + _
            M1(2, 1) * M2(1, 0) + _
            M1(2, 2) * M2(2, 0))
    Mr(0, 1) = (M1(0, 0) * M2(0, 1) + _
            M1(0, 1) * M2(1, 1) + _
            M1(0, 2) * M2(2, 1))
    Mr(1, 1) = (M1(1, 0) * M2(0, 1) + _
            M1(1, 1) * M2(1, 1) + _
            M1(1, 2) * M2(2, 1))
    Mr(2, 1) = (M1(2, 0) * M2(0, 1) + _
            M1(2, 1) * M2(1, 1) + _
            M1(2, 2) * M2(2, 1))
    Mr(0, 2) = (M1(0, 0) * M2(0, 2) + _
            M1(0, 1) * M2(1, 2) + _
            M1(0, 2) * M2(2, 2))
    Mr(1, 2) = (M1(1, 0) * M2(0, 2) + _
            M1(1, 1) * M2(1, 2) + _
            M1(1, 2) * M2(2, 2))
    Mr(2, 2) = (M1(2, 0) * M2(0, 2) + _
            M1(2, 1) * M2(1, 2) + _
            M1(2, 2) * M2(2, 2))
End Sub


Public Sub MxMT(Mr() As Double, M1() As Double, M2() As Double)
    Mr(0, 0) = (M1(0, 0) * M2(0, 0) + _
            M1(0, 1) * M2(0, 1) + _
            M1(0, 2) * M2(0, 2))
    Mr(1, 0) = (M1(1, 0) * M2(0, 0) + _
            M1(1, 1) * M2(0, 1) + _
            M1(1, 2) * M2(0, 2))
    Mr(2, 0) = (M1(2, 0) * M2(0, 0) + _
            M1(2, 1) * M2(0, 1) + _
            M1(2, 2) * M2(0, 2))
    Mr(0, 1) = (M1(0, 0) * M2(1, 0) + _
            M1(0, 1) * M2(1, 1) + _
            M1(0, 2) * M2(1, 2))
    Mr(1, 1) = (M1(1, 0) * M2(1, 0) + _
            M1(1, 1) * M2(1, 1) + _
            M1(1, 2) * M2(1, 2))
    Mr(2, 1) = (M1(2, 0) * M2(1, 0) + _
            M1(2, 1) * M2(1, 1) + _
            M1(2, 2) * M2(1, 2))
    Mr(0, 2) = (M1(0, 0) * M2(2, 0) + _
            M1(0, 1) * M2(2, 1) + _
            M1(0, 2) * M2(2, 2))
    Mr(1, 2) = (M1(1, 0) * M2(2, 0) + _
            M1(1, 1) * M2(2, 1) + _
            M1(1, 2) * M2(2, 2))
    Mr(2, 2) = (M1(2, 0) * M2(2, 0) + _
            M1(2, 1) * M2(2, 1) + _
            M1(2, 2) * M2(2, 2))
End Sub

Public Sub MTxM(Mr() As Double, M1() As Double, M2() As Double)
    Mr(0, 0) = (M1(0, 0) * M2(0, 0) + _
            M1(1, 0) * M2(1, 0) + _
            M1(2, 0) * M2(2, 0))
    Mr(1, 0) = (M1(0, 1) * M2(0, 0) + _
            M1(1, 1) * M2(1, 0) + _
            M1(2, 1) * M2(2, 0))
    Mr(2, 0) = (M1(0, 2) * M2(0, 0) + _
            M1(1, 2) * M2(1, 0) + _
            M1(2, 2) * M2(2, 0))
    Mr(0, 1) = (M1(0, 0) * M2(0, 1) + _
            M1(1, 0) * M2(1, 1) + _
            M1(2, 0) * M2(2, 1))
    Mr(1, 1) = (M1(0, 1) * M2(0, 1) + _
            M1(1, 1) * M2(1, 1) + _
            M1(2, 1) * M2(2, 1))
    Mr(2, 1) = (M1(0, 2) * M2(0, 1) + _
            M1(1, 2) * M2(1, 1) + _
            M1(2, 2) * M2(2, 1))
    Mr(0, 2) = (M1(0, 0) * M2(0, 2) + _
            M1(1, 0) * M2(1, 2) + _
            M1(2, 0) * M2(2, 2))
    Mr(1, 2) = (M1(0, 1) * M2(0, 2) + _
            M1(1, 1) * M2(1, 2) + _
            M1(2, 1) * M2(2, 2))
    Mr(2, 2) = (M1(0, 2) * M2(0, 2) + _
            M1(1, 2) * M2(1, 2) + _
            M1(2, 2) * M2(2, 2))
End Sub

Public Sub MxV(Vr() As Double, M1() As Double, V1() As Double)
    Vr(0) = (M1(0, 0) * V1(0) + _
         M1(0, 1) * V1(1) + _
         M1(0, 2) * V1(2))
    Vr(1) = (M1(1, 0) * V1(0) + _
         M1(1, 1) * V1(1) + _
         M1(1, 2) * V1(2))
    Vr(2) = (M1(2, 0) * V1(0) + _
         M1(2, 1) * V1(1) + _
         M1(2, 2) * V1(2))
End Sub

Public Sub MxVpV(Vr() As Double, M1() As Double, V1() As Double, V2() As Double)
    Vr(0) = (M1(0, 0) * V1(0) + _
         M1(0, 1) * V1(1) + _
         M1(0, 2) * V1(2) + _
         V2(0))
    Vr(1) = (M1(1, 0) * V1(0) + _
         M1(1, 1) * V1(1) + _
         M1(1, 2) * V1(2) + _
         V2(1))
    Vr(2) = (M1(2, 0) * V1(0) + _
         M1(2, 1) * V1(1) + _
         M1(2, 2) * V1(2) + _
         V2(2))
End Sub

Public Sub sMxVpV(Vr() As Double, s1 As Double, M1() As Double, V1() As Double, V2() As Double)
    Vr(0) = s1 * (M1(0, 0) * V1(0) + _
          M1(0, 1) * V1(1) + _
          M1(0, 2) * V1(2)) + _
          V2(0)
    Vr(1) = s1 * (M1(1, 0) * V1(0) + _
          M1(1, 1) * V1(1) + _
          M1(1, 2) * V1(2)) + _
          V2(1)
    Vr(2) = s1 * (M1(2, 0) * V1(0) + _
          M1(2, 1) * V1(1) + _
          M1(2, 2) * V1(2)) + _
          V2(2)
End Sub

Public Sub MTxV(Vr() As Double, M1() As Double, V1() As Double)
    Vr(0) = (M1(0, 0) * V1(0) + _
         M1(1, 0) * V1(1) + _
         M1(2, 0) * V1(2))
    Vr(1) = (M1(0, 1) * V1(0) + _
         M1(1, 1) * V1(1) + _
         M1(2, 1) * V1(2))
    Vr(2) = (M1(0, 2) * V1(0) + _
         M1(1, 2) * V1(1) + _
         M1(2, 2) * V1(2))
End Sub

Public Sub sMTxV(Vr() As Double, s1 As Double, M1() As Double, V1() As Double)
    Vr(0) = s1 * (M1(0, 0) * V1(0) + _
            M1(1, 0) * V1(1) + _
            M1(2, 0) * V1(2))
    Vr(1) = s1 * (M1(0, 1) * V1(0) + _
            M1(1, 1) * V1(1) + _
            M1(2, 1) * V1(2))
    Vr(2) = s1 * (M1(0, 2) * V1(0) + _
            M1(1, 2) * V1(1) + _
            M1(2, 2) * V1(2))
End Sub

Public Sub VmV(Vr() As Double, V1() As Double, V2() As Double)
    Vr(0) = V1(0) - V2(0)
    Vr(1) = V1(1) - V2(1)
    Vr(2) = V1(2) - V2(2)
End Sub

Public Sub VpV(Vr() As Double, V1() As Double, V2() As Double)
    Vr(0) = V1(0) + V2(0)
    Vr(1) = V1(1) + V2(1)
    Vr(2) = V1(2) + V2(2)
End Sub

Public Sub VpVxS(Vr() As Double, V1() As Double, V2() As Double, s As Double)
    Vr(0) = V1(0) + V2(0) * s
    Vr(1) = V1(1) + V2(1) * s
    Vr(2) = V1(2) + V2(2) * s
End Sub

Public Sub MskewV(m() As Double, V() As Double)
    m(0, 0) = 0
    m(1, 1) = 0
    m(2, 2) = 0
    m(1, 0) = V(2)
    m(0, 1) = -V(2)
    m(0, 2) = V(1)
    m(2, 0) = -V(1)
    m(1, 2) = -V(0)
    m(2, 1) = V(0)
End Sub

Public Sub VcrossV(Vr() As Double, V1() As Double, V2() As Double)
    Vr(0) = V1(1) * V2(2) - V1(2) * V2(1)
    Vr(1) = V1(2) * V2(0) - V1(0) * V2(2)
    Vr(2) = V1(0) * V2(1) - V1(1) * V2(0)
End Sub

Public Function Vlength(V() As Double) As Double
    Vlength = Sqr(V(0) * V(0) + V(1) * V(1) + V(2) * V(2))
End Function

Public Sub Vnormalize(V() As Double)
    Dim d As Double
    d = 1# / Sqr(V(0) * V(0) + V(1) * V(1) + V(2) * V(2))
    V(0) = V(0) * d
    V(1) = V(1) * d
    V(2) = V(2) * d
End Sub

Public Function VdotV(V1() As Double, V2() As Double) As Double
    VdotV = (V1(0) * V2(0) + V1(1) * V2(1) + V1(2) * V2(2))
End Function

Public Sub VxS(Vr() As Double, V() As Double, s As Double)
    Vr(0) = V(0) * s
    Vr(1) = V(1) * s
    Vr(2) = V(2) * s
End Sub

Public Sub Mqinverse(Mr() As Double, m() As Double)
    Dim i  As Long
    Dim j  As Long
    Dim i1 As Long
    Dim i2 As Long
    Dim j1 As Long
    Dim j2 As Long
    For i = 0 To 2
        For j = 0 To 2
            i1 = (i + 1) Mod 3
            i2 = (i + 2) Mod 3
            j1 = (j + 1) Mod 3
            j2 = (j + 2) Mod 3
            Mr(i, j) = (m(j1, i1) * m(j2, i2) - m(j1, i2) * m(j2, i1)):
        Next
    Next
End Sub

Public Sub ROT(a() As Double, i, j, k, l)
    g = a(i, j)
    h = a(k, l)
    a(i, j) = g - s * (h + g * tau)
    a(k, l) = h + s * (g - h * tau)
End Sub


int
inline
Meigen(double vout(3, 3), double dout(3), double a(3, 3))
{
  int i:
  double tresh,theta,tau,t,sm,s,h,g,c:
  int nrot:
  double b(3):
  double z(3):
  double v(3, 3):
  double d(3):
  
  V(0, 0) = V(1, 1) = V(2, 2) = 1#:
  V(0, 1) = V(1, 2) = V(2, 0) = 0#:
  V(0, 2) = V(1, 0) = V(2, 1) = 0#:
  
  b(0) = a(0, 0): d(0) = a(0, 0): z(0) = 0#:
  b(1) = a(1, 1): d(1) = a(1, 1): z(1) = 0#:
  b(2) = a(2, 2): d(2) = a(2, 2): z(2) = 0#:

  nrot = 0:
  
  for(i=0: i<50: i++)
    {

      sm=0.0: sm+=fabs(a(0, 1)): sm+=fabs(a(0, 2)): sm+=fabs(a(1, 2)):
      if (sm == 0.0) { McM(vout,v): VcV(dout,d): return i: }
      
      if (i < 3) tresh=0.2*sm/(3*3): else tresh=0.0:
      
      {
    g = 100# * rfabs(a(0, 1)):
    if (i>3 && rfabs(d(0))+g==rfabs(d(0)) && rfabs(d(1))+g==rfabs(d(1)))
      a(0, 1) = 0#:
    else if (rfabs(a(0, 1))>tresh)
      {
        h = d(1) - d(0):
        if (rfabs(h)+g == rfabs(h)) t=(a(0, 1))/h:
        Else
          {
        theta = 0.5 * h / (a(0, 1)):
        T = 1# / (rfabs(theta) + sqrt(1# + theta * theta)):
        if (theta < 0.0) t = -t:
          }
        c = 1# / sqrt(1 + T * T): s = T * c: tau = s / (1# + c): h = T * a(0, 1):
        z(0) -= h: z(1) += h: d(0) -= h: d(1) += h:
        a(0, 1) = 0#:
        ROT(a,0,2,1,2): ROT(v,0,0,0,1): ROT(v,1,0,1,1): ROT(v,2,0,2,1):
        nrot++:
      }
      }

      {
    g = 100# * rfabs(a(0, 2)):
    if (i>3 && rfabs(d(0))+g==rfabs(d(0)) && rfabs(d(2))+g==rfabs(d(2)))
      a(0, 2) = 0#:
    else if (rfabs(a(0, 2))>tresh)
      {
        h = d(2) - d(0):
        if (rfabs(h)+g == rfabs(h)) t=(a(0, 2))/h:
        Else
          {
        theta = 0.5 * h / (a(0, 2)):
        T = 1# / (rfabs(theta) + sqrt(1# + theta * theta)):
        if (theta < 0.0) t = -t:
          }
        c = 1# / sqrt(1 + T * T): s = T * c: tau = s / (1# + c): h = T * a(0, 2):
        z(0) -= h: z(2) += h: d(0) -= h: d(2) += h:
        a(0, 2) = 0#:
        ROT(a,0,1,1,2): ROT(v,0,0,0,2): ROT(v,1,0,1,2): ROT(v,2,0,2,2):
        nrot++:
      }
      }


      {
    g = 100# * rfabs(a(1, 2)):
    if (i>3 && rfabs(d(1))+g==rfabs(d(1)) && rfabs(d(2))+g==rfabs(d(2)))
      a(1, 2) = 0#:
    else if (rfabs(a(1, 2))>tresh)
      {
        h = d(2) - d(1):
        if (rfabs(h)+g == rfabs(h)) t=(a(1, 2))/h:
        Else
          {
        theta = 0.5 * h / (a(1, 2)):
        T = 1# / (rfabs(theta) + sqrt(1# + theta * theta)):
        if (theta < 0.0) t = -t:
          }
        c = 1# / sqrt(1 + T * T): s = T * c: tau = s / (1# + c): h = T * a(1, 2):
        z(1) -= h: z(2) += h: d(1) -= h: d(2) += h:
        a(1, 2) = 0#:
        ROT(a,0,1,0,2): ROT(v,0,1,0,2): ROT(v,1,1,1,2): ROT(v,2,1,2,2):
        nrot++:
      }
      }

      b(0) += z(0): d(0) = b(0): z(0) = 0.0:
      b(1) += z(1): d(1) = b(1): z(1) = 0.0:
      b(2) += z(2): d(2) = b(2): z(2) = 0.0:
      
    }

  fprintf(stderr, "eigen: too many iterations in Jacobi transform (%d).\n", i):

  return i:
}

Private Sub LogToFile(texto As String, Optional ff As Integer = 0)
    Dim ff As Integer
    If ff = 0 Then ff = FreeFile
    Open App.Path & "\Log.txt" For Append As #ff
    Print #ff, texto
    Close #ff
End Sub


